import "./interfaces.js";
import type { PgSourceExtensions, PgSourceRefExtensions, PgSourceRelationExtensions, PgTypeCodecExtensions } from "@dataplan/pg";
type ArrayOrDirect<T> = Array<T> | T;
/**
 * Takes a smart tags object and extracts the 'behavior' (or 'behaviour')
 * property and coerces it to be a string. Returns null if no behavior was
 * specified (in which case the default behavior should be used).
 */
export declare function getBehavior(extensions: ArrayOrDirect<Partial<PgSourceExtensions | PgSourceRelationExtensions | PgTypeCodecExtensions | PgSourceRefExtensions> | undefined>): string | null;
export {};
//# sourceMappingURL=behavior.d.ts.map