import type { PgClient, WithPgClient } from "@dataplan/pg";
import type { PromiseOrDirect } from "grafast";
/**
 * Get or build the 'withPgClient' callback function for a given database
 * config, caching it to make future lookups faster.
 */
export declare function getWithPgClientFromPgConfig(config: GraphileConfig.PgDatabaseConfiguration): PromiseOrDirect<WithPgClient>;
export declare function withPgClientFromPgConfig<T>(config: GraphileConfig.PgDatabaseConfiguration, pgSettings: {
    [key: string]: string;
} | null, callback: (client: PgClient) => T | Promise<T>): Promise<T>;
export declare function withSuperuserPgClientFromPgConfig<T>(config: GraphileConfig.PgDatabaseConfiguration, pgSettings: {
    [key: string]: string;
} | null, callback: (client: PgClient) => T | Promise<T>): Promise<T>;
//# sourceMappingURL=pgConfigs.d.ts.map