import type { PgFunctionSourceOptions, PgSourceOptions } from "@dataplan/pg";
import { PgSource } from "@dataplan/pg";
import type { PluginHook } from "graphile-config";
import type { PgProc } from "pg-introspection";
declare global {
    namespace GraphileBuild {
        interface Inflection {
            functionSourceName(this: Inflection, details: {
                databaseName: string;
                pgProc: PgProc;
            }): string;
            functionRecordReturnCodecName(this: Inflection, details: {
                databaseName: string;
                pgProc: PgProc;
            }): string;
        }
        interface GatherOptions {
            /**
             * If true, we'll treat all arguments that don't have defaults as being
             * required.
             */
            pgStrictFunctions?: boolean;
        }
    }
}
declare module "@dataplan/pg" {
    interface PgTypeColumnExtensions {
        argIndex?: number;
        argName?: string;
    }
}
declare global {
    namespace GraphileConfig {
        interface GatherHelpers {
            pgProcedures: {
                getSource(databaseName: string, pgProc: PgProc): Promise<PgSource<any, any, any, any> | null>;
            };
        }
        interface GatherHooks {
            pgProcedures_PgSource: PluginHook<(event: {
                source: PgSource<any, any, any, any>;
                pgProc: PgProc;
                databaseName: string;
            }) => void | Promise<void>>;
            pgProcedures_functionSource_options: PluginHook<(event: {
                databaseName: string;
                pgProc: PgProc;
                options: PgFunctionSourceOptions<any, any, any>;
            }) => void | Promise<void>>;
            pgProcedures_PgSource_options: PluginHook<(event: {
                databaseName: string;
                pgProc: PgProc;
                options: PgSourceOptions<any, any, any, any>;
            }) => void | Promise<void>>;
        }
    }
}
export declare const PgProceduresPlugin: GraphileConfig.Plugin;
//# sourceMappingURL=PgProceduresPlugin.d.ts.map